#include "debug.h"

/*Funcao que mostra o que deveria aparecer na tela (Usada no Poster)*/
void phony()
{
	printf("disk0->part4:/# list\n");
	printf("    .                     directory\n");
	printf("    ..                    directory\n");
	printf("    .pulse                directory\n");
	printf("    .ure                  directory\n");
	printf("    bin                   directory\n");
	printf("    boot                  directory\n");
	printf("    cdrom                 directory\n");
	printf("    dev                   directory\n");
	printf("    etc                   directory\n");
	printf("    home                  directory\n");
	printf("    lib                   directory\n");
	printf("    lost+found            directory\n");
	printf("    media                 directory\n");
	printf("    mnt                   directory\n");
	printf("    opt                   directory\n");
	printf("    proc                  directory\n");
	printf("    r_home                directory\n");
	printf("    run                   directory\n");
	printf("    sbin                  directory\n");
	printf("    selinux               directory\n");
	printf("    srv                   directory\n");
	printf("    sys                   directory\n");
	printf("    tmp                   directory\n");
	printf("    usr                   directory\n");
	printf("    var                   directory\n");
	printf("    .pulse-cookie         file\n");
	printf("    initrd.img            file\n");
	printf("    initrd.img.old        file\n");
	printf("    vmlinux               file\n");
	printf("    vmlinux.old           file\n\n");
	printf("disk0->part4:/# extract initrd.img\n\n");
	printf("Extracting initrd.img to X:/Arquivos/Linux_files/\n");
	printf("     10%% done\n");
	printf("     20%% done\n");
	printf("     30%% done\n");
	printf("     40%% done\n");
	printf("     50%% done\n");
	printf("     60%% done\n");
	printf("     70%% done\n");
	printf("     80%% done\n");
	printf("     90%% done\n");
	printf("    100%% done\n\n");
	printf("disk0->part4:/#");
}

/*Imprime um numero dado em setores, em bytes - Usada para depuracao*/
void print_sector_to_bytes (unsigned int bytes_per_sector, unsigned int sectors)
{
	DWORDLONG in_bytes;
	DWORD low;
	LONG high;
	
	in_bytes = sectors * bytes_per_sector;
	low = (DWORD) (in_bytes & 0xffffffff);
	high = (DWORD) ((((sectors >> 16 )* bytes_per_sector) >> 16) & 0xffffffff);
	printf("%x%x", (unsigned int) high, (unsigned int) low);
	fprintf(Log, "%x%x", (unsigned int) high, (unsigned int) low);
	
}

/*Funcao que imprime informacoes sobre o superbloco*/
void print_superblock (superblock* sb)
{
	printf("Total Inodes: %d\n",sb->total_inodes);
	printf("Total Blocks: %d\n",sb->total_blocks);
	printf("Block Size: %d\n",sb->block_size);
	printf("Inode Size: %d\n",sb->inode_size);
	printf("Blocks per BG: %d\n",sb->blocks_per_bg);
	printf("Inodes per BG: %d\n",sb->inodes_per_bg);
	printf("Type: %x\n",sb->type);
	printf("Version: %d\n",sb->version);
	printf("Reserved Blocks: %d\n",sb->reserved_blocks);
	printf("Amount of BGs: %d\n",sb->bgs);
	printf("Group Descriptor Size: %d\n",sb->gd_size);
	
	fprintf(Log, "Total Inodes: %d\n",sb->total_inodes);
	fprintf(Log, "Total Blocks: %d\n",sb->total_blocks);
	fprintf(Log, "Block Size: %d\n",sb->block_size);
	fprintf(Log, "Inode Size: %d\n",sb->inode_size);
	fprintf(Log, "Blocks per BG: %d\n",sb->blocks_per_bg);
	fprintf(Log, "Inodes per BG: %d\n",sb->inodes_per_bg);
	fprintf(Log, "Type: %x\n",sb->type);
	fprintf(Log, "Version: %d\n",sb->version);
	fprintf(Log, "Reserved Blocks: %d\n",sb->reserved_blocks);
	fprintf(Log, "Amount of BGs: %d\n",sb->bgs);
	fprintf(Log, "Group Descriptor Size: %d\n",sb->gd_size);
	
	if (sb->flex_bg)
	{
		fprintf(Log, "Size of a flex BG (in BGs): %d\n",sb->flex_bg);
		printf("Size of a flex BG (in BGs): %d\n",sb->flex_bg);
	}
	
}

/*Imprime os dados presentes no buffer - Usada para depuracao*/
void print_buffer(unsigned char* buffer, unsigned int size)
{
	int i;
	for (i = 0; i < size; i++)
	{
		if(i%16 == 0){
			/*j = i - 16;
			if (j >= 0)
			{
				for (j=j; j < i; j++)
					printf("%c ", buffer[j]);
			}*/
			printf("\n");
			fprintf(Log, "\n");
		}
		if (i % 1024 == 0){ printf("\n\n"); fprintf(Log, "\n\n");}
		printf("%2x ", buffer[i]);
		fprintf(Log, "%2x ", buffer[i]);
	}
	printf("\n");
	fprintf(Log, "\n");
}

/*Recebe uma entrada da tabela de particao e imprime os dados relevantes - Usada para depuracao*/
void print_partition_info(unsigned char* part)
{
	unsigned char* aux;
	printf("Partition Data:\nType: ");
	fprintf(Log, "Partition Data:\nType: ");
	partition_type((unsigned int) part[PART_TYPE_OFFSET]);
	printf("\nStarting point: 0x");
	fprintf(Log, "\nStarting point: 0x");
	aux = extract_from_buffer (part, PART_START_OFFSET, PART_START_OFFSET+3);
	print_sector_to_bytes (512, convert_to_int (aux, 4));
	printf(" (B) - 0x%x (sectors)\nSize: 0x", convert_to_int (aux, 4));
	fprintf(Log, " (B) - 0x%x (sectors)\nSize: 0x", convert_to_int (aux, 4));
	aux = extract_from_buffer (part, PART_SIZE_OFFSET, PART_SIZE_OFFSET+3);
	print_sector_to_bytes (512, convert_to_int (aux, 4));
	printf(" (B) - 0x%x (sectors)\n\n", convert_to_int (aux, 4));
	fprintf(Log," (B) - 0x%x (sectors)\n\n", convert_to_int (aux, 4));
}
