#ifndef MACROS
#define MACROS


/*Macros*/
#define MAX_DRIVES 16
#define MBR_SIZE 512
#define MIN_BYTES_PER_SECTOR 512

#define MAXHEAD 256
#define MAXCYL  1024
#define MAXSEC  63

#define PART_TABLE_BEGIN 0x1BE
#define PART_TYPE_OFFSET 4
#define PART_START_OFFSET 8
#define PART_SIZE_OFFSET 12
#define PART_CHS_OFFSET 5


/**********************************************************************************/
/*** SUPERBLOCK -> SB                                                           ***/
/*** OFFSET -> OFF                                                              ***/
/*** INODE -> IN                                                                ***/
/*** BLOCK -> BK                                                                ***/
/*** SIZE -> SZ                                                                 ***/
/*** TOTAL -> T                                                                 ***/
/*** BLOCK GROUP -> BG                                                          ***/
/*** SIGNATURE -> SIG                                                           ***/
/*** VERSION -> VS                                                              ***/
/*** RESERVED -> RV                                                             ***/
/*** GROUP DESCRIPTOR -> GD                                                     ***/
/**********************************************************************************/
#define SB_OFF 1024
#define SB_SZ 1024
#define SB_T_IN_OFF 0x0   /*Ext4 compatible*/
#define SB_T_BKS_OFF 0x4  /*Ext4 compatible*/
#define SB_RV_BKS_OFF 0x8     /*Ext4 compatible*/
#define SB_BK_SZ_OFF 0x18 /*Ext4 compatible*/
#define SB_BKS_PER_BG_OFF 0x20 /*Ext4 compatible*/
#define SB_IN_PER_BG_OFF 0x28 /*Ext4 compatible*/
#define SB_SIG_OFF 0x38 /*Ext4 compatible*/
#define SB_VS_OFF  0x4C /*Ext4 compatible*/
#define SB_IN_SZ_OFF 0x58 /*Ext4 compatible*/
#define SB_GD_SZ_OFF 0xFE /*Ext4 compatible*/
#define EXT_SIG 0xEF53 /*Ext4 compatible*/



#endif