#include "essentials.h"
/**********************************************************************************/
/*** Programa desenvolvido por Felipe Simionato Solferini (Solfer)                */
/**********************************************************************************/

/**********************************************************************************/
/*** Main()*/
/**********************************************************************************/


int main()
{
	int i, j, n, block_descriptor_begin, pasta;
	file_entry* x;
	DWORD low;
	LONG high;
	partition** part_list;
	unsigned char* buffer, *path, *atual;
	int empty_pos; /*primeira posicao vazia do vetor de particoes*/
	
	unsigned int sector_size, flags, entries;
	bklist* lista_de_blocos;
	
	/*Abrindo o arquivo de log*/
	
	Log = fopen("log.txt", "w");
	empty_pos = 0;
	j = 0;
	
	/*Devolve quantos disco tem no sistema*/
	/*Etapa 1*/
	n = n_disks();
	
	/*Etapa 2*/
	part_list = create_part_list(n, &empty_pos);
	/*Neste ponto, todos as particoes Ext estao devidamente identificadas*/
	/*As particoes que nao sao Ext possuem sb == NULL*/
	
	/*Carrega a primeira particao ext* que encontrar*/
	for (j = 0; j < empty_pos; j++)
	{
		if (part_list[j]->type == 0x83)
			break;
	}
	
	/*Lendo os Group Descriptors*/
	/*Se o Padding + Superbloco ocupam mais de um bloco*/
	while(1)
	{
	
	/*Etapa 3*/
	if (part_list[j]->sb->block_size < 2048)
	{
		/*Se eles ocuparem certinho os blocos*/
		if(part_list[j]->sb->block_size == 0)
		{
			block_descriptor_begin = 2048;
		}
		else
		{
			block_descriptor_begin = ((2048/part_list[j]->sb->block_size) + 1)*part_list[j]->sb->block_size;
		}
		
	}
	else
	{
		block_descriptor_begin = part_list[j]->sb->block_size;
	}
	buffer = read_disk(part_list[j]->disk_id, part_list[j]->high, part_list[j]->low, part_list[j]->sb->bgs*32, 0, block_descriptor_begin);
	part_list[j]->bg = create_bd_list(buffer, 32, part_list[j]->sb->bgs, part_list[j]->sb->block_size);
	
	sector_size = disk_bytes_per_sector(part_list[j]->disk_id);
	set_high_low_inode(&low, &high, 2, part_list[j]->sb->inode_size, part_list[j]->sb->inodes_per_bg , part_list[j]->bg);
	
	/*Essa gambiarra eh pq o read_disk soh le multiplos de setor*/
	buffer = read_disk(part_list[j]->disk_id, part_list[j]->high, part_list[j]->low, part_list[j]->sb->block_size, high, (low/sector_size)*sector_size);
	buffer = extract_from_buffer(buffer,low%sector_size,(low%sector_size) + part_list[j]->sb->inode_size);
	flags = convert_to_int(extract_from_buffer(buffer,0x20,0x23),4);
	
	
	
	
	/*Abrindo a pasta raiz*/
	x = file_entry_alloc();

	
	for (lista_de_blocos = read_inode_blocks(extract_from_buffer(buffer, 0x28,0x63), part_list[j], flags); lista_de_blocos != NULL; lista_de_blocos = lista_de_blocos->next)
	{
		
		for(i = 0; i < lista_de_blocos->len; i++)
		{
			buffer = read_disk(part_list[j]->disk_id, part_list[j]->high, part_list[j]->low, part_list[j]->sb->block_size, lista_de_blocos->high, lista_de_blocos->low + i*part_list[j]->sb->block_size);
			x->dir = create_directory (lista_de_blocos, 1, part_list[j], &entries);
			x->entries = entries;
		}
	}	
	
	atual = (unsigned char*) ".";
	while(1)
	{
		path = string_alloc(255);
		GetCurrentDirectory(255, (LPSTR) path);
		printf("%s:%s>", path, atual);
		pasta = entrada(x);
		if ((pasta >= 0) && (pasta < x->entries))
		{
			
			set_high_low_inode(&low, &high, x->dir[pasta]->inode, part_list[j]->sb->inode_size, part_list[j]->sb->inodes_per_bg , part_list[j]->bg);
			
			/*Essa gambiarra eh pq o read_disk soh le multiplos de setor*/
			buffer = read_disk(part_list[j]->disk_id, part_list[j]->high, part_list[j]->low, part_list[j]->sb->block_size, high, (low/sector_size)*sector_size);
			buffer = extract_from_buffer(buffer,low%sector_size,(low%sector_size) + part_list[j]->sb->inode_size);
			flags = convert_to_int(extract_from_buffer(buffer,0x20,0x23),4);
			
			buffer = extract_from_buffer(buffer, 0x28,0x63);
			lista_de_blocos = read_inode_blocks(buffer, part_list[j], flags);
			if(x->dir[pasta]->type == 0x1)
				extract(x->dir[pasta]->name,x->dir[pasta]->inode, lista_de_blocos, part_list[j]);
			else if(x->dir[pasta]->type == 0x2)
			{
				atual = x->dir[pasta]->name;
				x->dir = create_directory (lista_de_blocos, 1, part_list[j], &entries);
				x->entries = entries;
			}
			/*Muda a particao*/
		}
		else if (pasta >= 0x1000000)
		{
			if (pasta - 0x1000000 < empty_pos)
			{
				if(part_list[pasta - 0x1000000]->sb != NULL)
				{
					j = pasta - 0x1000000;
					break;
				}
			}
			printf("Comando invalido.\n");
		}
		else if (pasta != -2)
		{
			printf("Comando invalido.\n");
		}
	}
	
	}
	
	fclose(Log);
	
	return 0;
}
	




/**********************************************************************************/

