#include "read.h"

void read_partition_table (int id, partition** (*part_list), int *empty_pos)
{
	/*Declaracao de variaveis*/
	unsigned char* mbr;
	unsigned char* part;
	int i, n;
	DWORD low, rel_low;
	LONG  high, rel_high;
	unsigned int bytes_per_sector;
	/*unsigned int sectors_per_track;
	unsigned int tracks_per_cylinder;*/
	unsigned int sectors;
	
	/*Abre o disco*/
	
	/*Recupera a informacoes do disco*/
	bytes_per_sector = disk_bytes_per_sector(id);
	/*sectors_per_track = disk_sectors_per_track(id);
	tracks_per_cylinder = disk_tracks_per_cylinder(id);*/
	/*Le as informacoes da MBR e joga num buffer*/
	mbr = read_disk(id,0,0,MBR_SIZE,0,0);
	n = 4;
	rel_low = 0;
	rel_high = 0;
	for (i = 0; i < n; i++)
	{
		part = extract_from_buffer (mbr, PART_TABLE_BEGIN + i*16, PART_TABLE_BEGIN +15 +i*16);
		if ((((part[PART_TYPE_OFFSET] != 0xf) && (part[PART_TYPE_OFFSET] != 0x5)) && (part[PART_TYPE_OFFSET] != 0x0))){
			sectors = convert_to_int (extract_from_buffer(part, PART_START_OFFSET, PART_START_OFFSET +3), 4);
			set_high_low(&low, &high, bytes_per_sector, sectors);
			(*part_list)[(*empty_pos)++] = part_alloc(part[PART_TYPE_OFFSET], high+rel_high, (low+rel_low)&0xffffffff, id);
		}
		if ((part[PART_TYPE_OFFSET] == 0xf))
		{
			rel_high = 0;
			rel_low = 0;
			i = -1;
			n = 2;
			sectors = convert_to_int (extract_from_buffer(part, PART_START_OFFSET, PART_START_OFFSET +3), 4);
			set_high_low (&low, &high,bytes_per_sector, sectors);
			
			mbr = read_disk(id,high+rel_high,(low+rel_low)&0xffffffff,MBR_SIZE,0,0);
			rel_low = low;
			rel_high = high;
		}
		
		else if (part[PART_TYPE_OFFSET] == 0x5)
		{
			i = -1; 
			n = 2;
			
			sectors = convert_to_int (extract_from_buffer(part, PART_START_OFFSET, PART_START_OFFSET +3), 4);
			
			set_high_low (&low, &high,bytes_per_sector, sectors);
			if(low+rel_low < rel_low)
			{
				rel_high++;
			}
			mbr = read_disk(id,rel_high+high,rel_low+low,MBR_SIZE,0,0);
		}
	}
	fclose(Log);
}




/*Le 'len' dados a partir de 'high_pos low_pos' na particicao que comeca em "HIGH LOW"*/
unsigned char* read_disk(int disk_id, LONG high, DWORD low, DWORD len, LONG high_pos, DWORD low_pos)
{
	HANDLE disk;
	unsigned char* buffer;
	BOOL ret;
	DWORD bytes_read;
	LARGE_INTEGER address, offset, debug;
	
	disk = open_disk(disk_id);
	
	address.LowPart = low;
	address.HighPart = high;
	offset.LowPart =  low_pos;
	offset.HighPart = high_pos;
	buffer = string_alloc(len);
	/*Coloca o ponteiro de arquivo no inicio da particao desejada*/
	SetFilePointerEx(disk, address, NULL, FILE_BEGIN);
	
	/*Verifica qual eh a posicao atual*/
	debug.LowPart = 0;
	debug.HighPart = 0;
	SetFilePointerEx(disk, debug, &debug, FILE_CURRENT);
	
	/*Move o ponteiro para o ponto que deseja ser lido*/
	SetFilePointerEx(disk, offset, NULL, FILE_CURRENT);
	
	
	
	/*Verifica qual eh a posicao atual*/
	debug.LowPart = 0;
	debug.HighPart = 0;
	SetFilePointerEx(disk, debug, &debug, FILE_CURRENT);
	
	/*Le a quantidade de bytes desejada*/
	ret = ReadFile(disk, buffer, len, &bytes_read, NULL);
	if(!ret)
	{
		printf("Nao leu!\n");
		fprintf(Log, "Nao leu!\n");
	}
	else if (bytes_read != len)
	{
		printf("Leu menos do que devia!!\n");
		fprintf(Log, "Leu menos do que devia!!\n");
	}
	
	close_disk(disk);
	return buffer;
	
}

