/*Definicao das estruturas usadas no programa*/

#ifndef STRUCTS
#define STRUCTS

#include <Windows.h>
#include <WinIoCtl.h>

/*Estrutura que armazena os dados do Superbloco*/
typedef struct sb{
	unsigned int total_inodes;
	unsigned int total_blocks;
	unsigned int block_size;
	unsigned int inode_size;
	unsigned int blocks_per_bg;
	unsigned int inodes_per_bg;
	unsigned int type;
	unsigned int version;
	unsigned int reserved_blocks;
	unsigned int flex_bg;
	unsigned int bgs;
	unsigned int gd_size;
	
}superblock;

/*Estrutura que armazena os dados de um block group*/
typedef struct bg{
	LONG high_inode_table; /*32 bits menos significativos da localizao da tabela de inodes*/
	DWORD  low_inode_table; /*32 bits mais significativos da localizao da tabela de inodes*/
}
blockgroup;

/*Estrutura que armazena os dados da particao Ext{2,3,4}*/
typedef struct ext{
	unsigned int disk_id; /*A qual disco a particao pertence*/
	unsigned int type; /*Se  Ext2->2, Ext3->3, Ext4->4*/
	char name[255];    /*Nome que o usuario da para a particao*/
	LONG high;         /*16 bits mais significativos da posicao de inicio da particao*/
	DWORD low;         /*32 bits menos significativos da posicao de inicio da particao*/
	superblock* sb;    /*Aponta para a estrutura com as informacoes do superbloco*/
	blockgroup** bg;   /*Aponta para um vetor cujo indice aponta para a estrutura com as informacoes do block group*/
}partition;


/*Estrututa que armazena um arquivo*/
typedef struct file{
	int entries; /*Quantidade de entradas do diretorio. -1 se nao for diretorio*/
	unsigned int type;
	unsigned int inode;
	unsigned int size;
	unsigned char* name;
	struct file** dir; /*Vetor com todas as entradas do diretorio; NULL se for um arquivo ou diretorio no incializado; Um elemento NULL indica o final do vetor*/
}file_entry;

typedef struct blocklist{
	LONG high; /*bytes*/
	DWORD low; /*bytes*/
	unsigned int len;
	unsigned int order;
	struct blocklist* next;
}bklist;


#endif